# TheLineSegClass.py
# cs 1110 profs
# April 2016

from SimpleGraphics import *
from ThePointClass import *
from random import uniform as randu

class  LineSeg(object):
    """
    Attribute:
         P1: endpoint [Point]
         P2: endpoint [Point]
    """
    def __init__(self,P1,P2):
        self.P1 = P1
        self.P2 = P2
        
    def Blipped(self,rightProb=0):
        """ Returns a length-4 list K of line segments that represents
        the blipped version of self. The items in K satisfy these
        properties:
                    K[0].P1 and self.P1  represent the same point
                    K[0].P2 and K[1].P1  represent the same point
                    K[1].P2 and K[2].P1  represent the same point
                    K[2].P2 and K[3].P1  represent the same point
                    K[3].P2 and self.P2  represent the same point
        PreC: rightProb is the probability that the "blip" is on the
        right as you "walk" from self.P1 to self.P2.
        """
        P1 = self.P1
        P2 = self.P2
        Q1 = P1.Ave(P2,1/3.0)
        Q2 = P1.Ave(P2,2/3.0)
        M1 = P1.Ave(P2,1/2.0)
        tStar = 1/sqrt(12.)
        if randu(0,1)<=rightProb:
            tStar = -tStar
        T = Point(M1.x+tStar*(P1.y-P2.y),M1.y+tStar*(P2.x-P1.x))
        
        K = [LineSeg(P1,Q1),LineSeg(Q1,T),
             LineSeg(T,Q2),LineSeg(Q2,P2)]
        return K

